Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access.cpp	(revision 88)
@@ -0,0 +1,240 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::Icache_Access"
+  Icache_Access::Icache_Access 
+  (
+#ifdef SYSTEMC
+   sc_module_name name,
+#else
+   string name,
+#endif
+#ifdef STATISTICS
+   morpheo::behavioural::Parameters_Statistics * param_statistics,
+#endif
+   morpheo::behavioural::core::icache_access::Parameters * param,
+   morpheo::behavioural::Tusage_t usage
+   ):
+    _name              (name)
+    ,_param            (param)
+    ,_usage            (usage)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    usage_environment(_usage);
+
+#if DEBUG_Core == true
+    log_printf(INFO,Core,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
+    log_printf(INFO,Icache_Access,FUNCTION,_("<%s> : Allocation"),_name.c_str());
+
+    allocation (
+#ifdef STATISTICS
+		param_statistics
+#endif
+		);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {	
+	log_printf(INFO,Icache_Access,FUNCTION,_("<%s> : Allocation of statistics"),_name.c_str());
+
+	statistics_allocation(param_statistics);
+      }
+#endif
+
+#ifdef VHDL
+    if (usage_is_set(_usage,USE_VHDL))
+      {
+	// generate the vhdl
+	log_printf(INFO,Icache_Access,FUNCTION,_("<%s> : Generate the vhdl"),_name.c_str());
+	
+	vhdl();
+      }
+#endif
+
+#ifdef SYSTEMC
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+	log_printf(INFO,Icache_Access,FUNCTION,_("<%s> : Method - transition"),_name.c_str());
+
+	SC_METHOD (transition);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).pos();
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
+
+// 	log_printf(INFO,Icache_Access,FUNCTION,_("<%s> : Method - genMoore"),_name.c_str());
+
+// 	SC_METHOD (genMoore);
+// 	dont_initialize ();
+// 	sensitive << (*(in_CLOCK)).neg(); // need internal register
+	
+// # ifdef SYSTEMCASS_SPECIFIC
+// 	// List dependency information
+// # endif    
+
+	log_printf(INFO,Icache_Access,FUNCTION,_("<%s> : Method - genMealy_req"),_name.c_str());
+
+	SC_METHOD (genMealy_req);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg(); // need internal register
+
+	for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
+	  sensitive << (*(in_ICACHE_REQ_ACK [i]));
+	for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+	  for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	    {
+	      sensitive << (*(in_CONTEXT_REQ_VAL        [i][j]))
+			<< (*(in_CONTEXT_REQ_ADDRESS    [i][j]))
+			<< (*(in_CONTEXT_REQ_TYPE       [i][j]));
+	      if (_param->_have_port_packet_id [i][j])
+	      sensitive << (*(in_CONTEXT_REQ_PACKET_ID  [i][j]));
+	    }
+
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+
+	for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
+	  {
+	    for (uint32_t x=0; x<_param->_nb_icache_port; ++x)
+	      {
+		(*(out_ICACHE_REQ_VAL       [i])) (*(in_ICACHE_REQ_ACK [x]));
+		if (_param->_have_port_icache_thread_id)
+		(*(out_ICACHE_REQ_THREAD_ID [i])) (*(in_ICACHE_REQ_ACK [x]));
+		if (_param->_have_port_icache_packet_id)
+		(*(out_ICACHE_REQ_PACKET_ID [i])) (*(in_ICACHE_REQ_ACK [x]));
+		(*(out_ICACHE_REQ_ADDRESS   [i])) (*(in_ICACHE_REQ_ACK [x]));
+		(*(out_ICACHE_REQ_TYPE      [i])) (*(in_ICACHE_REQ_ACK [x]));
+	      }
+	    for (uint32_t x=0; x<_param->_nb_front_end; ++x)
+	      for (uint32_t y=0; y<_param->_nb_context[x]; ++y)
+		{
+		  (*(out_ICACHE_REQ_VAL       [i])) (*(in_CONTEXT_REQ_VAL        [x][y]));
+		  if (_param->_have_port_packet_id [x][y])
+		  (*(out_ICACHE_REQ_PACKET_ID [i])) (*(in_CONTEXT_REQ_PACKET_ID  [x][y]));
+		  (*(out_ICACHE_REQ_ADDRESS   [i])) (*(in_CONTEXT_REQ_ADDRESS    [x][y]));
+		  (*(out_ICACHE_REQ_TYPE      [i])) (*(in_CONTEXT_REQ_TYPE       [x][y]));
+		}
+	  }
+
+	for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+	  for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	    {
+	      for (uint32_t x=0; x<_param->_nb_front_end; ++x)
+		for (uint32_t y=0; y<_param->_nb_context[x]; ++y)
+		  (*(out_CONTEXT_REQ_ACK [i][j])) (*(in_CONTEXT_REQ_VAL        [x][y]));
+
+	      for (uint32_t x=0; x<_param->_nb_icache_port; ++x)
+		(*(out_CONTEXT_REQ_ACK [i][j])) (*(in_ICACHE_REQ_ACK [x]));
+	    }
+# endif    
+
+	log_printf(INFO,Icache_Access,FUNCTION,_("<%s> : Method - genMealy_rsp"),_name.c_str());
+
+	SC_METHOD (genMealy_rsp);
+	dont_initialize ();
+	sensitive << (*(in_CLOCK)).neg(); // need internal register
+	for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
+	  {
+	    sensitive << (*(in_ICACHE_RSP_VAL         [i]))
+		      << (*(in_ICACHE_RSP_ERROR       [i]));
+	    if (_param->_have_port_icache_thread_id)
+	    sensitive << (*(in_ICACHE_RSP_THREAD_ID   [i]));
+	    if (_param->_have_port_icache_packet_id)
+	    sensitive << (*(in_ICACHE_RSP_PACKET_ID   [i]));
+
+	    for (uint32_t j=0; j<_param->_icache_nb_instruction[i]; ++j)
+	      sensitive << (*(in_ICACHE_RSP_INSTRUCTION [i][j]));
+	  }
+	
+	for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+	  for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	    sensitive << (*(in_CONTEXT_RSP_ACK [i][j]));
+
+
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+
+	for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
+	  {
+	    if (_param->_have_port_icache_thread_id)
+	    (*(out_ICACHE_RSP_ACK [i])) (*(in_ICACHE_RSP_THREAD_ID   [i]));
+
+	    for (uint32_t x=0; x<_param->_nb_front_end; ++x)
+	      for (uint32_t y=0; y<_param->_nb_context[x]; ++y)
+		(*(out_ICACHE_RSP_ACK [i])) (*(in_CONTEXT_RSP_ACK [x][y]));
+	  }
+
+	for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+	  for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	    for (uint32_t x=0; x<_param->_nb_icache_port; ++x)
+	      {
+		if (_param->_have_port_icache_thread_id)
+		  {
+		    (*(out_CONTEXT_RSP_VAL         [i][j]))    (*(in_ICACHE_RSP_THREAD_ID   [x]));
+		    if (_param->_have_port_packet_id [i][j])
+		    (*(out_CONTEXT_RSP_PACKET_ID   [i][j]))    (*(in_ICACHE_RSP_THREAD_ID   [x]));
+		    (*(out_CONTEXT_RSP_ERROR       [i][j]))    (*(in_ICACHE_RSP_THREAD_ID   [x]));
+		    for (uint32_t k=0; k<_param->_nb_instruction [i][j]; ++k)
+		    (*(out_CONTEXT_RSP_INSTRUCTION [i][j][k])) (*(in_ICACHE_RSP_THREAD_ID   [x]));
+		  }
+
+		(*(out_CONTEXT_RSP_VAL         [i][j]))    (*(in_ICACHE_RSP_VAL         [x]));
+		if (_param->_have_port_packet_id [i][j])
+		(*(out_CONTEXT_RSP_PACKET_ID   [i][j]))    (*(in_ICACHE_RSP_PACKET_ID   [x]));
+		(*(out_CONTEXT_RSP_ERROR       [i][j]))    (*(in_ICACHE_RSP_ERROR       [x]));
+		for (uint32_t k=0; k<_param->_nb_instruction [i][j]; ++k)
+                  for (uint32_t y=0; y<_param->_icache_nb_instruction[x]; ++y)
+                    (*(out_CONTEXT_RSP_INSTRUCTION [i][j][k])) (*(in_ICACHE_RSP_INSTRUCTION [x][y]));
+	      }
+# endif
+	
+#endif
+      }
+    log_end(Icache_Access,FUNCTION);
+  };
+    
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::~Icache_Access"
+  Icache_Access::~Icache_Access (void)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {
+	statistics_deallocation();
+      }
+#endif
+
+    log_printf(INFO,Icache_Access,FUNCTION,_("<%s> : Deallocation"),_name.c_str());
+    deallocation ();
+
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_allocation.cpp	(revision 88)
@@ -0,0 +1,142 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+#include "Behavioural/include/Allocation.h"
+#include "Common/include/Max.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::allocation"
+  void Icache_Access::allocation (
+#ifdef STATISTICS
+			       morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+			       void
+#endif
+			       )
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    _component   = new Component (_usage);
+
+    Entity * entity = _component->set_entity (_name       
+					      ,"Icache_Access"
+#ifdef POSITION
+					      ,COMBINATORY 
+#endif
+					      );
+
+    _interfaces = entity->set_interfaces();
+
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      Interface * interface = _interfaces->set_interface(""
+#ifdef POSITION
+							 ,IN
+							 ,SOUTH,
+							 _("Generalist interface")
+#endif
+							 );
+      
+      in_CLOCK        = interface->set_signal_clk              ("clock" ,1, CLOCK_VHDL_YES);
+      in_NRESET       = interface->set_signal_in  <Tcontrol_t> ("nreset",1, RESET_VHDL_YES);
+    }
+
+    // ~~~~~[ Interface "icache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC1_INTERFACE("icache_req",WEST,OUT,_("Request to instruction cache"),_param->_nb_icache_port);
+      
+      ALLOC1_VALACK_OUT(out_ICACHE_REQ_VAL         ,VAL);
+      ALLOC1_VALACK_IN ( in_ICACHE_REQ_ACK         ,ACK);
+      ALLOC1_SIGNAL_OUT(out_ICACHE_REQ_THREAD_ID   ,"thread_id",Tcontext_t           ,_param->_size_icache_thread_id);
+      ALLOC1_SIGNAL_OUT(out_ICACHE_REQ_PACKET_ID   ,"packet_id",Tpacket_t            ,_param->_size_icache_packet_id);
+      ALLOC1_SIGNAL_OUT(out_ICACHE_REQ_ADDRESS     ,"address"  ,Ticache_address_t    ,_param->_size_address         );
+      ALLOC1_SIGNAL_OUT(out_ICACHE_REQ_TYPE        ,"type"     ,Ticache_type_t       ,_param->_size_icache_type     );
+    }
+
+    // ~~~~~[ Interface "icache_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  
+    {
+      ALLOC1_INTERFACE("icache_rsp",WEST,IN ,_("Respons from instruction cache"),_param->_nb_icache_port);
+
+      ALLOC1_VALACK_IN ( in_ICACHE_RSP_VAL         ,VAL);
+      ALLOC1_VALACK_OUT(out_ICACHE_RSP_ACK         ,ACK);
+      ALLOC1_SIGNAL_IN ( in_ICACHE_RSP_THREAD_ID   ,"thread_id"  ,Tcontext_t           ,_param->_size_icache_thread_id);
+      ALLOC1_SIGNAL_IN ( in_ICACHE_RSP_PACKET_ID   ,"packet_id"  ,Tpacket_t            ,_param->_size_icache_packet_id);
+      ALLOC1_SIGNAL_IN ( in_ICACHE_RSP_ERROR       ,"error"      ,Ticache_error_t      ,_param->_size_icache_error    );
+    }
+    {
+      // NOTE : max_nb_instruction is too wide ...
+      ALLOC2_INTERFACE("icache_rsp",WEST,IN ,_("Respons from instruction cache"),_param->_nb_icache_port,_param->_icache_nb_instruction[it1]);
+
+      _ALLOC2_SIGNAL_IN ( in_ICACHE_RSP_INSTRUCTION ,"instruction",Ticache_instruction_t,_param->_size_instruction,_param->_nb_icache_port,_param->_icache_nb_instruction[it1]);
+    }
+
+    // ~~~~~[ Interface "context_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC2_INTERFACE("context_req",EAST,IN ,_("Request from context_unit."),_param->_nb_front_end, _param->_nb_context[it1]);
+
+      _ALLOC2_VALACK_IN ( in_CONTEXT_REQ_VAL        ,VAL,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_VALACK_OUT(out_CONTEXT_REQ_ACK        ,ACK,_param->_nb_front_end, _param->_nb_context[it1]);
+//    _ALLOC2_SIGNAL_IN ( in_CONTEXT_REQ_THREAD_ID  ,"thread_id"  ,Tcontext_t           ,_param->_size_);
+      _ALLOC2_SIGNAL_IN ( in_CONTEXT_REQ_PACKET_ID  ,"packet_id"  ,Tpacket_t            ,_param->_size_packet_id[it1][it2],_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_CONTEXT_REQ_ADDRESS    ,"address"    ,Ticache_address_t    ,_param->_size_address            ,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_IN ( in_CONTEXT_REQ_TYPE       ,"type"       ,Ticache_type_t       ,_param->_size_icache_type        ,_param->_nb_front_end, _param->_nb_context[it1]);
+    }
+
+    // ~~~~~[ Interface "context_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    {
+      ALLOC2_INTERFACE("context_rsp",EAST,OUT,_("Respons to context_unit."),_param->_nb_front_end, _param->_nb_context[it1]);
+
+      _ALLOC2_VALACK_OUT(out_CONTEXT_RSP_VAL        ,VAL,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_VALACK_IN ( in_CONTEXT_RSP_ACK        ,ACK,_param->_nb_front_end, _param->_nb_context[it1]);
+//    _ALLOC2_SIGNAL_OUT(out_CONTEXT_RSP_THREAD_ID  ,"thread_id"  ,Tcontext_t           ,_param->_size_                   ,_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_OUT(out_CONTEXT_RSP_PACKET_ID  ,"packet_id"  ,Tpacket_t            ,_param->_size_packet_id[it1][it2],_param->_nb_front_end, _param->_nb_context[it1]);
+      _ALLOC2_SIGNAL_OUT(out_CONTEXT_RSP_ERROR      ,"error"      ,Ticache_error_t      ,_param->_size_icache_error       ,_param->_nb_front_end, _param->_nb_context[it1]);
+    }
+    {
+      ALLOC3_INTERFACE("context_rsp",EAST,OUT,_("Respons to context_unit."),_param->_nb_front_end, _param->_nb_context[it1],_param->_nb_instruction[it1][it2]);
+
+      _ALLOC3_SIGNAL_OUT(out_CONTEXT_RSP_INSTRUCTION,"instruction",Ticache_instruction_t,_param->_size_instruction,_param->_nb_front_end, _param->_nb_context[it1],_param->_nb_instruction[it1][it2]);
+    }
+
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+        // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#ifdef STATISTICS
+        _internal_ICACHE_REQ_NB_ACCESS         = new uint32_t [_param->_nb_icache_port];
+        _internal_ICACHE_REQ_NB_ACCESS_CONFLIT = new uint32_t [_param->_nb_icache_port];
+#endif
+      }
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+    _priority  = new generic::priority::Priority (_name+"_priority",
+						  _param->_priority      ,
+						  _param->_load_balancing,
+						  _param->_nb_front_end  ,
+						  _param->_nb_context    ,
+						  _param->_nb_front_end  );
+
+#ifdef POSITION
+    if (usage_is_set(_usage,USE_POSITION))
+	_component->generate_file();
+#endif
+
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_deallocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_deallocation.cpp	(revision 88)
@@ -0,0 +1,75 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+#include "Behavioural/include/Allocation.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::deallocation"
+  void Icache_Access::deallocation (void)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
+	delete    in_CLOCK ;
+	delete    in_NRESET;
+
+        DELETE1_SIGNAL(out_ICACHE_REQ_VAL         ,_param->_nb_icache_port,1);
+        DELETE1_SIGNAL( in_ICACHE_REQ_ACK         ,_param->_nb_icache_port,1);
+        DELETE1_SIGNAL(out_ICACHE_REQ_THREAD_ID   ,_param->_nb_icache_port,_param->_size_icache_thread_id);
+        DELETE1_SIGNAL(out_ICACHE_REQ_PACKET_ID   ,_param->_nb_icache_port,_param->_size_icache_packet_id);
+        DELETE1_SIGNAL(out_ICACHE_REQ_ADDRESS     ,_param->_nb_icache_port,_param->_size_address);
+        DELETE1_SIGNAL(out_ICACHE_REQ_TYPE        ,_param->_nb_icache_port,_param->_size_icache_type);
+  
+        DELETE1_SIGNAL( in_ICACHE_RSP_VAL         ,_param->_nb_icache_port,1);
+        DELETE1_SIGNAL(out_ICACHE_RSP_ACK         ,_param->_nb_icache_port,1);
+        DELETE1_SIGNAL( in_ICACHE_RSP_THREAD_ID   ,_param->_nb_icache_port,_param->_size_icache_thread_id);
+        DELETE1_SIGNAL( in_ICACHE_RSP_PACKET_ID   ,_param->_nb_icache_port,_param->_size_icache_packet_id);
+        DELETE1_SIGNAL( in_ICACHE_RSP_ERROR       ,_param->_nb_icache_port,_param->_size_icache_error);
+        DELETE2_SIGNAL( in_ICACHE_RSP_INSTRUCTION ,_param->_nb_icache_port,_param->_icache_nb_instruction[it1],_param->_size_instruction);
+        
+        DELETE2_SIGNAL( in_CONTEXT_REQ_VAL        ,_param->_nb_front_end, _param->_nb_context[it1],1                                );
+        DELETE2_SIGNAL(out_CONTEXT_REQ_ACK        ,_param->_nb_front_end, _param->_nb_context[it1],1                                );
+//      DELETE2_SIGNAL( in_CONTEXT_REQ_THREAD_ID                                                  ,_param->_size_);
+        DELETE2_SIGNAL( in_CONTEXT_REQ_PACKET_ID  ,_param->_nb_front_end, _param->_nb_context[it1],_param->_size_packet_id[it1][it2]);
+        DELETE2_SIGNAL( in_CONTEXT_REQ_ADDRESS    ,_param->_nb_front_end, _param->_nb_context[it1],_param->_size_address            );
+        DELETE2_SIGNAL( in_CONTEXT_REQ_TYPE       ,_param->_nb_front_end, _param->_nb_context[it1],_param->_size_icache_type        );
+        					                                                  
+        DELETE2_SIGNAL(out_CONTEXT_RSP_VAL        ,_param->_nb_front_end, _param->_nb_context[it1],1                                );
+        DELETE2_SIGNAL( in_CONTEXT_RSP_ACK        ,_param->_nb_front_end, _param->_nb_context[it1],1                                );
+//      DELETE2_SIGNAL(out_CONTEXT_RSP_THREAD_ID  ,_param->_nb_front_end, _param->_nb_context[it1],_param->_size_                   );
+        DELETE2_SIGNAL(out_CONTEXT_RSP_PACKET_ID  ,_param->_nb_front_end, _param->_nb_context[it1],_param->_size_packet_id[it1][it2]);
+        DELETE2_SIGNAL(out_CONTEXT_RSP_ERROR      ,_param->_nb_front_end, _param->_nb_context[it1],_param->_size_icache_error       );
+        DELETE3_SIGNAL(out_CONTEXT_RSP_INSTRUCTION,_param->_nb_front_end, _param->_nb_context[it1],_param->_nb_instruction[it1][it2],_param->_size_instruction        );
+
+        // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#ifdef STATISTICS
+        delete [] _internal_ICACHE_REQ_NB_ACCESS        ;
+        delete [] _internal_ICACHE_REQ_NB_ACCESS_CONFLIT;
+#endif
+      }
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+    delete _priority;
+
+    delete _component;
+
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_end_cycle.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_end_cycle.cpp	(revision 88)
@@ -0,0 +1,43 @@
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::end_cycle"
+void Icache_Access::end_cycle ()
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//  sc_start(0);
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
+#endif
+
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp	(revision 88)
@@ -0,0 +1,91 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::genMealy_req"
+  void Icache_Access::genMealy_req (void)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    Tcontrol_t icache_req_val [_param->_nb_icache_port];
+    for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
+      {
+	icache_req_val [i] = 0;
+
+#ifdef STATISTICS
+	_internal_ICACHE_REQ_NB_ACCESS         [i] = 0;
+	_internal_ICACHE_REQ_NB_ACCESS_CONFLIT [i] = 0;
+#endif
+      }
+    
+    Tcontrol_t context_req_ack [_param->_nb_front_end][_param->_max_nb_context];
+    for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+      for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	context_req_ack [i][j] = 0;
+	
+    std::list<generic::priority::select_t> * select = _priority ->select();
+    for (std::list<generic::priority::select_t>::iterator it=select ->begin();
+	 it!=select->end();
+	 ++it)
+      {
+	uint32_t num_front_end = it->grp;
+	uint32_t num_context   = it->elt;
+	
+	if (PORT_READ(in_CONTEXT_REQ_VAL [num_front_end][num_context]))
+	  {
+	    uint32_t   num_port       = _param->_table_routing[num_front_end][num_context];
+	    Tcontrol_t icache_req_ack = PORT_READ(in_ICACHE_REQ_ACK [num_port]);
+
+#ifdef STATISTICS
+	    if (icache_req_ack)
+	      {
+		_internal_ICACHE_REQ_NB_ACCESS [num_port] ++;
+		if (icache_req_val [num_port])
+		_internal_ICACHE_REQ_NB_ACCESS_CONFLIT [num_port] ++;
+	      }
+#endif
+	    if (not icache_req_val [num_port])
+	      {
+		icache_req_val  [num_port] = 1;
+		context_req_ack [num_front_end][num_context] = icache_req_ack;
+
+		if (_param->_have_port_icache_thread_id)
+		PORT_WRITE(out_ICACHE_REQ_THREAD_ID [num_port], _param->_translate_context_to_thread[num_front_end][num_context]);
+// 		if (_param->_have_port_icache_packet_id)
+                if (_param->_have_port_packet_id [num_front_end][num_context])
+		PORT_WRITE(out_ICACHE_REQ_PACKET_ID [num_port], PORT_READ(in_CONTEXT_REQ_PACKET_ID [num_front_end][num_context]));
+		PORT_WRITE(out_ICACHE_REQ_ADDRESS   [num_port], PORT_READ(in_CONTEXT_REQ_ADDRESS   [num_front_end][num_context]));
+		PORT_WRITE(out_ICACHE_REQ_TYPE      [num_port], PORT_READ(in_CONTEXT_REQ_TYPE      [num_front_end][num_context]));
+	      }
+	  }
+      }
+
+    for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
+      PORT_WRITE(out_ICACHE_REQ_VAL [i], icache_req_val [i]);
+    
+    for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+      for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	PORT_WRITE(out_CONTEXT_REQ_ACK [i][j], context_req_ack [i][j]);
+
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_rsp.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_rsp.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_rsp.cpp	(revision 88)
@@ -0,0 +1,89 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::genMealy_rsp"
+  void Icache_Access::genMealy_rsp (void)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    Tcontrol_t context_rsp_val [_param->_nb_front_end][_param->_max_nb_context];
+    for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+      for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	context_rsp_val [i][j] = 0;
+
+    for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
+      {
+	Tcontrol_t val = PORT_READ(in_ICACHE_RSP_VAL [i]);
+	Tcontrol_t ack;
+	
+	Tcontext_t thread_id = (_param->_have_port_icache_thread_id)?PORT_READ(in_ICACHE_RSP_THREAD_ID [i]):0;
+
+#ifdef DEBUG_TEST
+        if (thread_id > _param->_nb_thread)
+          throw ERRORMORPHEO(FUNCTION,_("invalid thread_id.\n"));
+#endif
+
+	if (val)
+	  {
+	    Tcontext_t front_end_id = _param->_translate_thread_to_context  [thread_id];
+	    Tcontext_t context_id   = _param->_translate_thread_to_front_end[thread_id];
+	    
+// 	    log_printf(TRACE,Icache_Access,FUNCTION,"thread_id     : %d",thread_id);
+// 	    log_printf(TRACE,Icache_Access,FUNCTION,"front_end_id  : %d",front_end_id);
+// 	    log_printf(TRACE,Icache_Access,FUNCTION,"context_id    : %d",context_id);
+	    
+#ifdef DEBUG_TEST
+	    if (front_end_id > _param->_nb_front_end)
+	      throw ERRORMORPHEO(FUNCTION,_("invalid front_end_id.\n"));
+
+	    if (context_id > _param->_nb_context[front_end_id])
+	      throw ERRORMORPHEO(FUNCTION,_("invalid context_id.\n"));
+
+	    if (_param->_table_routing [front_end_id][context_id] != i)
+	      throw ERRORMORPHEO(FUNCTION,_("invalid route.\n"));
+#endif
+
+	    ack = PORT_READ(in_CONTEXT_RSP_ACK [front_end_id][context_id]);
+	    
+	    context_rsp_val [front_end_id][context_id] = 1;
+//          if (_param->_have_port_icache_packet_id)
+	    if (_param->_have_port_packet_id [front_end_id][context_id])
+	    PORT_WRITE(out_CONTEXT_RSP_PACKET_ID   [front_end_id][context_id], PORT_READ(in_ICACHE_RSP_PACKET_ID   [i]));
+	    PORT_WRITE(out_CONTEXT_RSP_ERROR       [front_end_id][context_id], PORT_READ(in_ICACHE_RSP_ERROR       [i]));
+	    
+	    for (uint32_t j=0; j<_param->_nb_instruction [front_end_id][context_id]; ++j)
+              PORT_WRITE(out_CONTEXT_RSP_INSTRUCTION [front_end_id][context_id][j], PORT_READ(in_ICACHE_RSP_INSTRUCTION [i][j]));
+	  }
+	else
+	  ack = 0;
+		
+	PORT_WRITE(out_ICACHE_RSP_ACK [i],ack);
+      }
+
+    for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+      for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	PORT_WRITE(out_CONTEXT_RSP_VAL [i][j], context_rsp_val [i][j]);
+
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_statistics_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_statistics_allocation.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_statistics_allocation.cpp	(revision 88)
@@ -0,0 +1,69 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace icache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Icache_Access::statistics_allocation"
+  void Icache_Access::statistics_allocation (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_begin(Icache_Access,FUNCTION);
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "Icache_Access",
+		      param_statistics);
+
+    _stat_nb_access         = new counter_t * [_param->_nb_icache_port];
+    _stat_nb_access_conflit = new counter_t * [_param->_nb_icache_port];
+
+    std::string _sum_nb_access         = "";
+    std::string _sum_nb_access_conflit = "";
+
+    for (uint32_t i=0; i<_param->_nb_icache_port; i++)
+      {
+	_stat_nb_access         [i] = _stat->create_counter("nb_access_"        +toString(i),"",toString(_("Total access achieved by all contexts (port %d)"),i));
+	_stat_nb_access_conflit [i] = _stat->create_counter("nb_access_conflit_"+toString(i),"",toString(_("Total access conducting a conflict (port %d)"),i));
+
+	if (i == 0)
+	  {
+	    _sum_nb_access         = "nb_access_0";
+	    _sum_nb_access_conflit = "nb_access_conflit_0";
+	  }
+	else
+	  {
+	    _sum_nb_access         = "+ nb_access_"         +toString(i)+" "+ _sum_nb_access        ;
+	    _sum_nb_access_conflit = "+ nb_access_conflit_" +toString(i)+" "+ _sum_nb_access_conflit;
+	  }
+	
+	_stat->create_expr_percent ("percent_access_conflit_"+toString(i), "nb_access_conflit_"+toString(i), "nb_access_"+toString(i),toString(_("Percent for total access conducting a conflict (port %d)"),i));
+
+
+	_stat->create_expr_average_by_cycle ("average_nb_icache_access_"+toString(i),"- nb_access_"+toString(i)+" nb_access_conflit_"+toString(i),"",toString(_("Average of icache access (port %d)"),i));
+      }
+
+    _stat->create_expr         ("nb_access"        , _sum_nb_access        , TYPE_COUNTER, "", _("Total access achieved by all contexts (all port)"));
+    _stat->create_expr         ("nb_access_conflit", _sum_nb_access_conflit, TYPE_COUNTER, "", _("Total access conducting a conflict (all port)"));
+
+    _stat->create_expr_percent ("percent_access_conflit", _sum_nb_access_conflit, _sum_nb_access,_("Percent for total access conducting a conflict"));
+
+    _stat->create_expr_average_by_cycle ("average_nb_icache_access","- nb_access nb_access_conflit","",_("Average of icache access (all port)"));
+    log_end(Icache_Access,FUNCTION);
+  };
+
+}; // end namespace icache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
